using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_Maestros._0_Modelos;
using Exferia_General;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;
using System.Data.SqlClient;
using System.Threading;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT " +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                         nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) +
                  " FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                  " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_EmbalajesPrincipal_Precios_Historico>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacioandas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Embalajes ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmbalaje != null)
                    {
                        ThreadStart obj_ThreadStart_EMBALAJE = new ThreadStart(Obtener_Embalaje_Modelo_Obtener);
                        Thread obj_Thread_EMBALAJE = new Thread(obj_ThreadStart_EMBALAJE);
                        obj_Thread_EMBALAJE.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_NomenclaturasPrecios ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idNomenclaturaPrecio != null)
                    {
                        ThreadStart obj_ThreadStart_NOMENCLATURAPRECIO = new ThreadStart(Obtener_NomenclaturaPrecio_Modelo_Obtener);
                        Thread obj_Thread_NOMENCLATURAPRECIO = new Thread(obj_ThreadStart_NOMENCLATURAPRECIO);
                        obj_Thread_NOMENCLATURAPRECIO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Embalaje_Modelo_Obtener()
        {
            try
            {
                MAE_Embalajes_Datos obj_MAE_Embalajes_Datos = new MAE_Embalajes_Datos();
                g_dnm_Modelo_Obtener.MAE_Embalajes = obj_MAE_Embalajes_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmbalaje);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_NomenclaturaPrecio_Modelo_Obtener()
        {
            try
            {
                MAE_NomenclaturasPrecios_Datos obj_MAE_NomenclaturasPrecios_Datos = new MAE_NomenclaturasPrecios_Datos();
                g_dnm_Modelo_Obtener.MAE_NomenclaturasPrecios = obj_MAE_NomenclaturasPrecios_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idNomenclaturaPrecio);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo> Obtener_Listado_PorArticulo(long _lng_idArticulo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo> lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.id) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idArticulo) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmbalaje) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idNomenclaturaPrecio) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmpresa) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.precio) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) + "," +
                       //Embalaje
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_Codigo) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_Descripcion) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_FechaBorrado) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.fechaBorrado) + "," +
                       //NomenclaturaPrecio
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_Codigo) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_Descripcion) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_FechaBorrado) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + "," +
                       //Empresa
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) +
                " FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                //Embalaje
                " LEFT JOIN " + nameof(MAE_Embalajes) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.id) +
                //NomenclaturaPrecio
                " LEFT JOIN " + nameof(MAE_NomenclaturasPrecios) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.id) +
                //Empresa
                " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id) +
                " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "=@idArticulo ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo",  _lng_idArticulo)
                };

                //Rellenar el Modelo
                lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

                if (lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo != null && lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Count > 0)
                {
                    DateTime dtt_Fecha = new DateTime(2000, 1, 1);
                    long lng_idNomenclaturaPrecio = -1;

                    foreach (INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo in lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.OrderBy(m => m.idNomenclaturaPrecio).ThenBy(m => m.fechaHora).ToList())
                    {
                        if (!lng_idNomenclaturaPrecio.Equals(mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idNomenclaturaPrecio))
                        {
                            dtt_Fecha = new DateTime(2000, 1, 1);
                            lng_idNomenclaturaPrecio = mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idNomenclaturaPrecio;
                        }

                        //Fecha inicio
                        mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Inicial = dtt_Fecha;


                        //Fecha Fin
                        mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Final = mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora.AddDays(-1);


                        //Actualizamos fecha inicial
                        dtt_Fecha = mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora;
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener_Listado_PorArticulo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo;
        }

        public INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo Obtener_Simple(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.id) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idArticulo) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmbalaje) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idNomenclaturaPrecio) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.idEmpresa) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.precio) + "=" + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) +
                       //Embalaje
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_Codigo) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_Descripcion) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Embalaje_FechaBorrado) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.fechaBorrado) + "," +
                       //NomenclaturaPrecio
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_Codigo) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_Descripcion) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.NomenclaturaPrecio_FechaBorrado) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + "," +
                       //Empresa
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                       nameof(INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) +
                " FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                //Embalaje
                " LEFT JOIN " + nameof(MAE_Embalajes) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + " = " + nameof(MAE_Embalajes) + "." + nameof(MAE_Embalajes.id) +
                //NomenclaturaPrecio
                " LEFT JOIN " + nameof(MAE_NomenclaturasPrecios) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + " = " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.id) +
                //Empresa
                " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id) +
                " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                if(mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo != null)
                {
                    DateTime dtt_Fecha = new DateTime(2000, 1, 1);

                    //Fecha inicio
                    mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Inicial = dtt_Fecha;
                    //Fecha Fin
                    mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.Fecha_Final = mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora.AddDays(-1);
                    //Actualizamos fecha inicial
                    dtt_Fecha = mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo.fechaHora;
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener_Simple), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Listado_Modelo;
        }

        public MAE_Articulos_EmbalajesPrincipal_Precios_Historico Obtener_PorArticuloNomenclaturaPrecioFecha(long _lng_idArticulo,long _lng_NomenclaturaPrecio,DateTime _dtt_FechaHora)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //fechas
                DateTime dtt_Fecha_Desde = new DateTime(_dtt_FechaHora.Year, _dtt_FechaHora.Month, _dtt_FechaHora.Day, 0, 0, 0);
                DateTime dtt_Fecha_Hasta = new DateTime(_dtt_FechaHora.Year, _dtt_FechaHora.Month, _dtt_FechaHora.Day, 23, 59, 59);

                string str_SQL =
                " SELECT " +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) +
                " FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "=@idArticulo AND " +
                            nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "=@idNomenclaturaPrecio AND " +
                            nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + ">@fechaHora " +
                            " ORDER BY " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + " ASC ";
                            ;

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo",  _lng_idArticulo),
                     new SqlParameter("@idNomenclaturaPrecio",  _lng_NomenclaturaPrecio),
                     new SqlParameter("@fechaHora",  dtt_Fecha_Hasta)
                };

                //Rellenar el Modelo
                List<MAE_Articulos_EmbalajesPrincipal_Precios_Historico> lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_EmbalajesPrincipal_Precios_Historico>(str_SQL, arr_Parametros).ToList();

                if (lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico != null && lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico.Count > 0)
                {
                    //Ver si hay algun registro par el dia de la fecha del documento
                    MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_ENFECHAABUSCAR = lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico.Where(m => m.fechaHora >= dtt_Fecha_Desde && m.fechaHora <= dtt_Fecha_Hasta).OrderByDescending(m => m.fechaHora).FirstOrDefault();
                    if (mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_ENFECHAABUSCAR != null)
                    {
                        mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_ENFECHAABUSCAR;
                    }
                    //buscar en el Listado el primero que encuentre
                    else
                    {
                        mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico.FirstOrDefault();
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener_PorArticuloNomenclaturaPrecioFecha), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_Articulos_EmbalajesPrincipal_Precios_Historico g_mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = null;
        public MAE_Articulos_EmbalajesPrincipal_Precios_Historico Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_EmbalajesPrincipal_Precios_Historico>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_Articulos_EmbalajesPrincipal_Precios_Historico> g_lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = null;
        public List<MAE_Articulos_EmbalajesPrincipal_Precios_Historico> Obtener_ModeloListado_Por_IdArticulo(long _lng_idArticulo)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) + "." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "=@idArticulo";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo",  _lng_idArticulo)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdArticulo), true);
            }

            return g_lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico;
        }

        #region Ejecutar consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_Articulos_EmbalajesPrincipal_Precios_Historico = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_EmbalajesPrincipal_Precios_Historico>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                      nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) +
                " FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_AGrabar = (MAE_Articulos_EmbalajesPrincipal_Precios_Historico)_mdl_obj;
                MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_DatosViejos = new MAE_Articulos_EmbalajesPrincipal_Precios_Historico();

                // Ver si existe ######################################################################
                MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final = Obtener_Modelo_Por_Id(mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final, mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_DatosViejos, false, false);

                    //Cargar los Datos Nuevos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_AGrabar, mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                                            " SET " +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "=@idArticulo," +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "=@idEmbalaje," +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "=@idNomenclaturaPrecio," +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "=@idEmpresa," +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "=@fechaHora," +
                                                  nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) + "=@precio" +
                                            " WHERE " +
                                                nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idArticulo",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idArticulo),
                        new SqlParameter("@idEmbalaje",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idEmbalaje),
                        new SqlParameter("@idNomenclaturaPrecio",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idNomenclaturaPrecio),
                        new SqlParameter("@idEmpresa",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idEmpresa),
                        new SqlParameter("@fechaHora",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.fechaHora),
                        new SqlParameter("@precio",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.precio),
                        new SqlParameter("@id", mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final = new MAE_Articulos_EmbalajesPrincipal_Precios_Historico();

                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_AGrabar, mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                                                " (" +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idArticulo) + "," +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmbalaje) + "," +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idNomenclaturaPrecio) + "," +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.idEmpresa) + "," +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.fechaHora) + "," +
                                                        nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.precio) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) +
                                                " VALUES " +
                                                " ( " +
                                                      "@idArticulo," +
                                                      "@idEmbalaje," +
                                                      "@idNomenclaturaPrecio," +
                                                      "@idEmpresa," +
                                                      "@fechaHora," +
                                                      "@precio" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idArticulo",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idArticulo),
                        new SqlParameter("@idEmbalaje",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idEmbalaje),
                        new SqlParameter("@idNomenclaturaPrecio",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idNomenclaturaPrecio),
                        new SqlParameter("@idEmpresa",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.idEmpresa),
                        new SqlParameter("@fechaHora",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.fechaHora),
                        new SqlParameter("@precio",  mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final.precio)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la trnasaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico), mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_DatosViejos, mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;


            //Se utiliza la transaccion por la llamada al procedimiento almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    MAE_Articulos_EmbalajesPrincipal_Precios_Historico mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################
                    
                    if(mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final != null)
                    {
                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                                                " WHERE " +
                                                    nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                                new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico), null, mdl_MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);

                        // Devolver también el Objeto
                        mdl_ValorDevuelto_Modelo.Id = _lng_id;

                        //Se termina la Transaccion Correctamente
                        transaccion_SQL.Complete();
                    }
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    transaccion_SQL.Dispose();
                   
                }
            }

            return mdl_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idPreciosHistorico = (List<long>)_mdl_obj;

                if (lst_idPreciosHistorico != null && lst_idPreciosHistorico.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idPreciosHistorico);

                    string str_SQL = " DELETE FROM " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico) +
                                     " WHERE " + nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico.id) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_EmbalajesPrincipal_Precios_Historico_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
